"""
Django settings for server project.

Generated by 'django-admin startproject' using Django 3.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

import os
from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

ALLOWED_HOSTS = None # overwrite this

AUTH_USER_MODEL = 'core.CerraxUser'

DEBUG = False

# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'website.apps.WebsiteConfig',
    'core.apps.CoreConfig',
    'lister.apps.ListerConfig',
    'docket.apps.DocketConfig',
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

ROOT_URLCONF = 'server.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
            ],
        },
    },
]

WSGI_APPLICATION = 'server.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}

# Logging settings
LOGS_DIR = os.path.join(BASE_DIR, 'logs')
MAX_LOGFILE_SIZE = 8000000  # 8 Megabytes

# 'standard' log has INFO level logging
DJANGO_LOG_LEVEL = 'INFO'
STANDARD_LOG_LEVEL = 'INFO'
# Make sure this log directory exists...
STANDARD_LOGFILE = os.path.join(LOGS_DIR, 'CxCloud.log')
MAX_STD_LOGFILES = 50
# 'error' log obviously is ERROR level logging
ERROR_LOGFILE = os.path.join(LOGS_DIR, 'CxCloud.err')
MAX_ERR_LOGFILES = 10
# 'django' logging is all the server stuff that is Django code, not our code
DJANGO_LOGFILE = os.path.join(LOGS_DIR, 'Django.log')
MAX_DJANGO_LOGFILES = 10

LOGGING = {
    'version': 1,
    'disable_existing_loggers': True,
    'formatters': {
        'verbose': {
            'format': '%(asctime)s %(levelname)-- s  %(name)s %(message)s'
        },
        'simple': {
            'format': '%(levelname)s %(message)s'
        },
    },
    'handlers': {
        'console': {
            'level': 'DEBUG',
            'class': 'logging.StreamHandler',
            'formatter': 'simple',
        },
        'django_logfile': {'level': os.getenv('DJANGO_LOG_LEVEL', DJANGO_LOG_LEVEL),
                           'class': 'concurrent_log_handler.ConcurrentRotatingFileHandler',
                           'filename': DJANGO_LOGFILE,
                           'maxBytes': MAX_LOGFILE_SIZE,
                           'backupCount': MAX_DJANGO_LOGFILES,
                           'formatter': 'verbose',
                           },
        'standard_logfile': {
            'level': STANDARD_LOG_LEVEL,
            'class': 'concurrent_log_handler.ConcurrentRotatingFileHandler',
            'filename': STANDARD_LOGFILE,
            'maxBytes': MAX_LOGFILE_SIZE,
            'backupCount': MAX_STD_LOGFILES,
            'formatter': 'verbose',
        },
        'error_logfile': {
            'level': 'ERROR',
            'class': 'concurrent_log_handler.ConcurrentRotatingFileHandler',
            'filename': ERROR_LOGFILE,
            'maxBytes': MAX_LOGFILE_SIZE,
            'backupCount': MAX_ERR_LOGFILES,
            'formatter': 'verbose',
        }
    },
    'loggers': {
        'django': {
            'handlers': ['console', 'django_logfile'],
            'level': os.getenv('DJANGO_LOG_LEVEL', DJANGO_LOG_LEVEL),
            'propogate': True
        },
        'django.request': {
            'handlers': ['console', 'django_logfile', 'standard_logfile', 'error_logfile'],
            'level': os.getenv('DJANGO_LOG_LEVEL', DJANGO_LOG_LEVEL),
            'propagate': False,
        },
        'django.security': {
            'handlers': ['console', 'django_logfile', 'error_logfile'],
            'level': 'ERROR',
            'propagate': False,
        },
        'cxcloud': {
            'handlers': ['console', 'standard_logfile', 'error_logfile'],
            'level': STANDARD_LOG_LEVEL,
            'propogate': True
        },
    },
}


# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'UTC'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'
STATIC_ROOT = os.path.join(BASE_DIR, 'static/')

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
